﻿using ComponentPractice.Models;
using Radzen;

namespace ComponentPractice.Services
{
    public class NorthwindDataService
    {
        private readonly HttpClient httpClient;
        private readonly Uri baseUri;

        public NorthwindDataService(string url = "https://services.radzen.com/odata/Northwind/")
        {
            baseUri = new Uri(url);
            httpClient = new HttpClient();
        }

        public async Task<ODataServiceResult<Customer>> GetCustomer()
        {
            var uri = new Uri(baseUri, "Customers");
            var httpRequestMessage = new HttpRequestMessage(HttpMethod.Get, uri);

            var response = await httpClient.SendAsync(httpRequestMessage);

            return await response.ReadAsync<ODataServiceResult<Customer>>();
        }
    }
}
